from visual import *

g = vector(0,-9.8,0)

class Cannon:
    def __init__(self, world,pitch=pi/4, angle=pi/4):
        self.world = world
        self.pitch=pitch
        self.angle=angle
        self.graphic=cylinder(radius=0.5, length=10)
        self.aim()
        self.vinitial = 20

    def aim(self):
        print "Cannon.aim()"
        direction = rotate(vector(1,0,0),angle=self.pitch)
        direction = rotate(direction,angle=self.angle,axis=(0,-1,0))
        self.graphic.axis=self.graphic.length*direction

    def fire(self):
        newball = sphere(pos=self.graphic.axis,radius=0.5,color=color.red)
        newball.v = self.vinitial*norm(self.graphic.axis)
        self.world.add(newball)

class World:
    def __init__(self):
        self.objects = []
    def add(self,newobject):
        self.objects.append(newobject)
    def step(self,dt):
        for obj in self.objects:
            obj.v += g*dt
            obj.pos += obj.v*dt
            #bounce
            if obj.pos.y<=0:
                obj.v.y = -0.8*obj.v.y
                obj.pos.y = 0
            #remove
            if obj.pos.x>100 or obj.pos.x<0 or obj.pos.z>100 or obj.pos.z<0:
                obj.visible=0
                self.objects.remove(obj)
